/*------------------------------------------------------------------------*/
/*                                                                        */
/*                           AMULET3 Simple Memory                        */
/*                                                                        */
/*                                             Created: JDG 11/12/96      */
/*                                       Last Modified: JDG   2/5/97      */
/*                                       SWI mods added: JVW  2/2/97      */
/*------------------------------------------------------------------------*/

freadfile(filename     : val(string),
          memory_array : var(int^40000)):
          expr(void) =
  (
    handle : var(file).
    number : var(int).

    i : var(int).

    handle := openin(filename);
    i := 0;
    while (!eof(handle)) do
      (
      number := freadint(handle);
      memory_array[i] := number;
      i := i + 1
      );

    printstr("(Pretend) Memory loaded\n")
  ).

/*------------------------------------------------------------------------*/

Memory(Iaddr : var(chan(Addr_bus_type)),
       op_code : var(chan(Data_bus_type)),
       Daddr   : var(chan(Addr_bus_type)),
       Dout    : var(chan(Data_bus_type))):
       expr(void) =
  (
  memory_array : var(int^40000).
  i            : var(int).
/* Following for SWI handling */
  L_handles    : var(file^100).
  nxt_hand     : var(int).


  Mem_port(Addr : var(chan(Addr_bus_type)),
           Data : var(chan(Data_bus_type))):
           expr(void) =
    (
    Qcol    : var(int).
    Aborted : var(bool).
/* Following for SWI handling */
    file_name    : var(int^16).
    Byte_sel     : var(int).  
    Word_sel     : var(int).  
    B_count      : var(int).  
    Rbase        : var(int).

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

do_SWI(SWI_type:val(int)) : expr(void) =
  (
  Rbase := 16#10;  /* Base of dumped reg set */
  (case SWI_type                                    /* Pick up SWI number */

    when 16#61 => /* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  Read clock to R0 */
      memory_array[Rbase+0] := now         /* LARD time returned in  Reg0 */

    when 16#63 =>  /* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Read time to R0 */
      memory_array[Rbase+0] := now         /* LARD time returned in  Reg0 */

    when 16#66 =>  /* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Open File */
    (
    inch         : var(int).  
    j : var(int).  

 /* Reg0 has file name pointer */
    Byte_sel := memory_array[Rbase+0] and 16#00000003;
    Word_sel := memory_array[Rbase+0] >> 2;
    j        := 0;
    B_count  := 0;
    repeat
      (
      inch := (memory_array[Word_sel] >> (Byte_sel * 8)) and 16#000000FF;
      if (B_count = 0) then                         /* First byte in word */
        file_name[j] := inch << 24
      else
        file_name[j] := file_name[j] or (inch << (8 * (3 - B_count)));
      Byte_sel := (Byte_sel + 1) and 16#00000003;
      if (Byte_sel = 0) then Word_sel := Word_sel + 1;
      B_count  := (B_count + 1)  and 16#00000003;
      if (B_count = 0) then j := j + 1
      ) until (inch = 0);

    (case memory_array[Rbase+1] /* Reg1 has file access info */

      when 16#00000000 =>                        /* "r" open for reading  */
        L_handles[nxt_hand] := openin(memstr(file_name, 0))

      when 16#00000001 =>               /* "rb" open for reading (binary) */
        L_handles[nxt_hand] := openin(memstr(file_name, 0))

      when 16#00000002 =>             /* "r+" open for update (read+write)*/
        L_handles[nxt_hand] := openin(memstr(file_name, 0))

      when 16#00000003 =>            /* "r+b" open for update (read+write)*/
        L_handles[nxt_hand] := openin(memstr(file_name, 0))

      when 16#00000004 =>                       /* "w" create for writing */
        L_handles[nxt_hand] := openout(memstr(file_name, 0))

      when 16#00000005 =>                       /* "wb" create for update */
        L_handles[nxt_hand] := openout(memstr(file_name, 0))

      when 16#00000006 =>                       /* "w+" create for update */
        L_handles[nxt_hand] := openout(memstr(file_name, 0))

      when 16#00000007 =>                     /* "w+b"  create for update */
        L_handles[nxt_hand] := openout(memstr(file_name, 0))

      when 16#00000008  =>          /* "a" append open for writing at eof */
        L_handles[nxt_hand] := openout(memstr(file_name, 0))

      when 16#00000009  =>         /* "ab" append open for writing at eof */
        L_handles[nxt_hand] := openout(memstr(file_name, 0))

      when 16#0000000A  =>        /* "a+"  append open for writing at eof */
        L_handles[nxt_hand] := openout(memstr(file_name, 0))

      when 16#0000000B  =>        /* "a+b" append open for writing at eof */
        L_handles[nxt_hand] := openout(memstr(file_name, 0))

       default
         (
         printstr("\n");
         printint(memory_array[Rbase+1]);
         printstr(" : Unrecognised file access\n")
         )
    );                                                     /* End of case */

    memory_array[Rbase+0] := nxt_hand; /* L_handles index returned in  Reg0 */
    nxt_hand := nxt_hand +1

    )      /* end of when 16#66 */


    when 16#68 => /* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> Close file with handle R0 */
      close(L_handles[memory_array[Rbase+0]])


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

    when 16#69 => /* Write R2 bytes from [R1] to file R0, R0 returns status */
      (
      outch        : var(int).  

      B_count  := memory_array[Rbase + 2];
      Byte_sel := memory_array[Rbase + 1] and 16#03;
      Word_sel := memory_array[Rbase + 1] >> 2;
      while B_count > 0 do
        (
        outch := ((memory_array[Word_sel] >> (Byte_sel * 8)) and 16#FF);
        fprintchar(L_handles[memory_array[Rbase+0]], cast(char, outch));
        Byte_sel := ((Byte_sel + 1) and 16#00000003);
        if (Byte_sel = 0) then Word_sel := Word_sel + 1;
        B_count := B_count - 1
        );
      memory_array[Rbase+0] :=  B_count          /* Return residual count */
                          /* what about return of STATUS ??  99999999999  */
      )

    when 16#6A => /* Read R2 bytes from file R0 to  [R1] R0 returns # unread  */
      (
      inch         : var(int).  

      B_count := memory_array[Rbase + 2];
      Byte_sel := memory_array[Rbase + 1] and 16#03;
      Word_sel := memory_array[Rbase + 1] >> 2;
      while ((B_count > 0) && !eof(L_handles[memory_array[Rbase+0]])) do
        (
        inch := cast(int, freadchar(L_handles[memory_array[Rbase+0]]));
        inch := (inch << (Byte_sel * 8));
        memory_array[Word_sel] := memory_array[Word_sel] or inch;
        Byte_sel := ((Byte_sel + 1) and 16#03);
        if (Byte_sel = 0) then Word_sel := Word_sel + 1;
        B_count := B_count - 1
        );
      memory_array[Rbase+0] :=  B_count          /* Return residual count */
    /* early EOF tested 9999 What else ????  */
      )

    when 16#70 => /* Install handler - Sometime 9999  */
      (
      printstr(" : SWI call to Install Handler\n")
      )

    default printstr("Bollocks!\n")

  )
  ).

/*>>>>>>>>>>>>>>>>>>>>>>> END of SWI handling <<<<<<<<<<<<<<<<<<<<<<<<<<*/

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

    Aborted := false;

    forever
      (
      mem_latch  : var(Addr_bus_type).
      data_value : var(Data_bus_type).
      mem_addr   : var(int).
      byte_sel   : var(int).

      Addr?(mem_latch := (?Addr));

      wait_for(MEM_delay);                                /* Memory delay */

      if (Aborted && (Qcol = mem_latch->Qcol)) then
        (                                    /* true _following_ an abort */
        printstr("MEM: ignoring cycle after abort\n");
        data_value->abort := true
        )                    /* Prevent further action until colour match */
      else
        (
        Qcol    := mem_latch->Qcol;               /* Adopt current colour */

        mem_addr := mem_latch->addr>>2;
        byte_sel := (mem_latch->addr) and 3;

        data_value->data  := 0;                      /* Just some default */

        if (mem_latch->addr = Tube_addr) then
          (
          data_value->abort := false;
          if ((mem_latch->Dout and 16#7F) = 4) then
            (printstr("Stopping\n"); Run := false)
          else
            (
            if ((mem_latch->Dout and 16#7F) = 5) then
              (printstr("{{Time is "); printint(now); printstr("}}\n"))
            else
              (
/*printstr("Tube := ");*/
              ASCII_out(mem_latch->Dout);
/*printstr("\n")*/ null
              )
            )
          )                                        /* End of Tube handler */
        else
          (
          if ((mem_latch->addr = SWI_addr) && (mem_latch->Write)) then
            (
            data_value->abort := false;
            do_SWI(mem_latch->Dout)
            )
          else
            (

            if ((mem_addr < 0) || (mem_addr >= 40000)) then/* Memory management*/
              (
if (mem_latch->Read) then printstr("MEM: Aborting on read from address ")
else                      printstr("MEM: Aborting on write to address ");
printhex(mem_latch->addr); printstr("\n");
              data_value->abort := true
              )
            else
              (
              data_value->abort := false;
              if (mem_latch->Read) then data_value->data := memory_array[mem_addr];
              if (mem_latch->Write) then
                (case mem_latch->Size
                  when 4 => 
                    (memory_array[mem_addr] := mem_latch->Dout)


                  when 1 =>
                    (case byte_sel
                      when 0 =>
                        (
                        memory_array[mem_addr] := memory_array[mem_addr] and 16#FFFFFF00;
                        mem_latch->Dout        := mem_latch->Dout        and 16#000000FF;
                        memory_array[mem_addr] := memory_array[mem_addr] or mem_latch->Dout
                        )

                      when 1 =>
                        (
                        memory_array[mem_addr] := memory_array[mem_addr] and 16#FFFF00FF;
                        mem_latch->Dout        := mem_latch->Dout        and 16#0000FF00;
                        memory_array[mem_addr] := memory_array[mem_addr] or mem_latch->Dout
                        )

                      when 2 =>
                        (
                        memory_array[mem_addr] := memory_array[mem_addr] and 16#FF00FFFF;
                        mem_latch->Dout        := mem_latch->Dout        and 16#00FF0000;
                        memory_array[mem_addr] := memory_array[mem_addr] or mem_latch->Dout
                        )

                      when 3 =>
                        (
                        memory_array[mem_addr] := memory_array[mem_addr] and 16#00FFFFFF;
                        mem_latch->Dout        := mem_latch->Dout        and 16#FF000000;
                        memory_array[mem_addr] := memory_array[mem_addr] or mem_latch->Dout
                        )

                    )

                  when 2 =>
                    (case (byte_sel and 2)
                      when 0 =>
                        (
                        memory_array[mem_addr] := memory_array[mem_addr] and 16#FFFF0000;
                        mem_latch->Dout        := mem_latch->Dout        and 16#0000FFFF;
                        memory_array[mem_addr] := memory_array[mem_addr] or mem_latch->Dout
                        )
                      when 2 =>
                        (
                        memory_array[mem_addr] := memory_array[mem_addr] and 16#0000FFFF;
                        mem_latch->Dout        := mem_latch->Dout        and 16#FFFF0000;
                        memory_array[mem_addr] := memory_array[mem_addr] or mem_latch->Dout
                        )
                    )

                  default
                    (
                    printint(mem_latch->Size);
                    printstr(" is not a legal transfer size\n")
                    )
                );    /* End of case */

              Aborted := data_value->abort

              )  /* End real memory service */
            )     /* End "not Tube or SWI"  */
          );              /* End "not Tube" */
        Data!data_value
        )
      )
    ).


  nxt_hand := 0;
/* ?? */

  i := 0;
  while (i<50) do (memory_array[i] := 0; i := i + 1);

  freadfile("programme", memory_array);                 /* Initialisation */

  (Mem_port(Iaddr, op_code) | Mem_port(Daddr, Dout))
  ).

/*------------------------------------------------------------------------*/

null

/*------------------------------------------------------------------------*/
