/*------------------------------------------------------------------------*/
/*                                                                        */
/*                 AMULET3 Asynchronous Island (main programme)           */
/*                                                                        */
/*                                             Created: JDG  17/1/97      */
/*                                       Last Modified: JDG   6/6/97      */
/*                                                                        */
/*------------------------------------------------------------------------*/
/*                                                                        */
/*------------------------------------------------------------------------*/
/*   COMMENT #0
use(marble).
     COMMENT #0    */
/*------------------------------------------------------------------------*/
/* Each MARBLE InterFace is assigned a unique identifier here             */
/*    COMMENT #1
AM3_I_MIF    : expr(int) = 0.
AM3_D_MIF    : expr(int) = 1.
Ext_MIF      : expr(int) = 2.
Hagenuk_MIF  : expr(int) = 3.
Register_MIF : expr(int) = 4.
DMAC_C_MIF   : expr(int) = 5.
DMAC_D_MIF   : expr(int) = 6.
ROM_MIF      : expr(int) = 7.

/* MARBLE bus                                                             */
BAC       : var(chan2t(BAC_type)).
BDC       : var(chan2t(BDC_type)).
Barb_chan : var(chan4b(void)^8).
BTS       : var(int).
      COMMENT #1    */

/* AMULET3 I/O                                                            */
Imem_addr : var(chan(Addr_bus_type)).        /* Instruction fetch address */
Imem_data : var(chan(Data_bus_type)).       /* Snooped value from Imemory */
Dmem_addr : var(chan(Mem_copro_bus_type)).          /* Data copro. output */
Dmem_data : var(chan(Data_bus_type)).               /* Data memory to CPU */

(

/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* MARBLE bus initialisation                                              */
/*    COMMENT #2

init_chan(BAC, "BAC");
init_chan(BDC, "BDC");
(i : var(int).
forseq i in 0 to 7 do
  init_chan(Barb_chan[i],"MARBLE Arbitration Channel "@i2s(i)));
      COMMENT #2     */

/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* AMULET3 I/O initialisation                                             */

init_chan(Imem_addr, "Fetch address");
init_chan(Imem_data, "Op_code");
init_chan(Dmem_addr, "Data/copro. out");
init_chan(Dmem_data, "Data data to CPU");

/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/**/
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

Run := false;       /* Ensure nothing starts yet; environment sets us off */

  (
    Environment                                /* Interrupt (etc.) inputs */
  |
/*    MARBLE_control(BAC, BDC, Barb_chan, BTS, bus_map)
  |
*/
    AMULET3(Imem_addr, Imem_data, Dmem_addr, Dmem_data)
  |
    Memory_support(Imem_addr, Imem_data, Dmem_addr, Dmem_data)
/*
    CPU_support(Imem_addr, Imem_data, Dmem_addr, Dmem_data,
                BAC, BDC,  Barb_chan, BTS,                      /* Bus ID */
                AM3_I_MIF, AM3_D_MIF)                /* Bus interface IDs */
  |
    External_IF(BAC, BDC, Barb_chan, BTS, Ext_MIF)
  |
    Hagenuk_IF(BAC, BDC, Barb_chan, BTS, Hagenuk_MIF)
  |
    Register_IF(BAC, BDC, Barb_chan, BTS, Register_MIF)
  |
    DMAC_IF(BAC, BDC, Barb_chan, BTS, DMAC_C_MIF, DMAC_D_MIF)
  |
    ROM_IF(BAC, BDC, Barb_chan, BTS, ROM_MIF)
*/
  )

)

/*------------------------------------------------------------------------*/
