/*------------------------------------------------------------------------*/
/*                                                                        */
/*                           AMULET3i Header File                         */
/*                                                                        */
/*                                             Created: JDG  19/2/97      */
/*                                       Last Modified: JDG   5/6/97      */
/*                                                                        */
/*------------------------------------------------------------------------*/
/* Use files                                                              */

use(channels).

/*------------------------------------------------------------------------*/
/* Record type declarations                                               */

Copro_type : type = record(use_copro::bool,
                            copro_no::int,
                               instr::int).

Addr_bus_type : type = record(addr::int,
                               seq::bool,
                              mode::int,
                              Qcol::int,
                              Read::bool,
                             Write::bool,
                              Size::int,
                              Dout::int,
                             extra::int).    /* Only used to flag PC load */

Mem_copro_bus_type : type = record(addr::int,
                                    seq::bool,
                                   mode::int,
                                   Qcol::int,
                                   Read::bool,
                                  Write::bool,
                                   Size::int,
                                   Dout::int,
                                  copro::Copro_type,
                             invalidate::bool).

Data_bus_type : type = record(data::int,
                             abort::bool,
                             extra::int,
                         bv_colour::int). /* for block view */

/*------------------------------------------------------------------------*/
/* Memory map                                                             */

Tube_addr     : expr(int) = 16#03000000.                  /* Tube address */
SWI_addr      : expr(int) = 16#03000004.       /* Trigger for SWI handler */

/*------------------------------------------------------------------------*/
/* Global variables                                                       */

dis_flag : var(bool).                 /* True to enable debug disassembly */

Run : var(bool).                           /* If false cause LARD to halt */
                                     /* Used to terminate test programmes */
watchdog : var(int).  /* Time log (written by IAI) far deadlock detection */

IRQ : var(bool).
FIQ : var(bool).

BTC_Enable  : var(bool).
Halt_Enable : var(bool).

/*------------------------------------------------------------------------*/

null

/*------------------------------------------------------------------------*/
