/*------------------------------------------------------------------------*/
/*                                                                        */
/*                           AMULET3 Thumb decoder                        */
/*                                                                        */
/*                                            Skeleton: JDG  13/1/97      */
/*                                            Modified: JDG  26/2/97      */
/*                                            Body added: JVW 5/3/97      */
/*                                            Modified: JDG   8/7/97      */
/*                                                                        */
/*------------------------------------------------------------------------*/
/*                                                                        */
/* Dabt_svc is no longer used                                             */
/*                                                                        */
/*------------------------------------------------------------------------*/

Thumb(In      : var(chan(Instr_pkt_type)),
      Out     : var(chan(Instr_pkt_type2)),
      Dabt_go : var(chan(void))):
      expr(void)=
 (

  latch   : var(Instr_pkt_type).
  output  : var(Instr_pkt_type2).

  forever
    (
    In?(latch:=(?In));

    output->PSR_ctrl := latch->PSR_ctrl;        /* Invariant in this unit */
    output->colour   := latch->colour;          /* Invariant in this unit */
    output->Dabt_svc := latch->Dabt_svc;        /* Invariant in this unit */
    output->bv_colour := latch->bv_colour;

    if (latch->PSR_ctrl->Thumb) then
      (                                                  /* In Thumb mode */
      PC_spec : var(int).

      PC_spec := latch->PC;
/* PC sent to Thumb Expander to suppress PC bit-1 for Format-12 Add to PC */

      if ((latch->PC and 16#00000002) = 0) then  /* L.S. half word wanted */
        (
        wait_for(Thumb_on_delay);

        if ((latch->extension and 16#20) != 0) then   /* Predicted "even" */
          (
          output->Op_code := latch->Op_code; /* Use ARM code if predicted */
          output->special := false
          )
        else
          Thumb_Ex(latch->Op_code,                      /* else decode it */
                   output->LSB,
                   output->special,
                   output->Op_code,
                   PC_spec);

        if ((latch->extension and 16#60) = 16#40) then /* Predicted "odd" */
          output->extension := 16#00             /* so no prediction here */
        else
          output->extension := latch->extension;               /* Default */
        output->PC := PC_spec;

        Out!output;

        PC_spec := latch->PC + 2         /* May be altered by ADD from PC */
        );

      /* Suppression of this cycle (after predicted branch) is optional   */
      if ((latch->extension and 16#20) = 0) then   /* No prediction (yet) */
        (                                          /* Send M.S. half word */
        wait_for(Thumb_on_delay);

        if ((latch->extension and 16#40) != 0) then    /* Predicted "odd" */
          (                                  /* Use ARM code if predicted */
          latch->extension := latch->extension or 16#20;   /* Rationalise */
          output->Op_code  := latch->Op_code;
          output->special  := false
          )
        else
          Thumb_Ex(latch->Op_code >> 16,                /* else decode it */
                   output->LSB,
                   output->special,
                   output->Op_code,
                   PC_spec);
        output->extension := latch->extension;
        output->PC        := PC_spec;

        Out!output
        )
      )                                                     /* Thumb mode */
    else
      (                                                    /* In ARM mode */
      if ((latch->extension = 0) &&       /* Possible copro. instruction? */
          (((latch->Op_code and 16#0E000000) = 16#0C000000)
        || ((latch->Op_code and 16#0F000000) = 16#0E000000))) then
        (
        wait_for(Copro_dec_delay);    /* Poll coprocessors: is op. taken? */

/* This should really talk to the coprocessors rather than call a function*/

                                        /* Coprocessor wants instruction? */
        if copro_test(latch->Op_code) then 
          output->extension := latch->extension /* Yes, continue normally */
        else
          (                                    /* No, make as "undefined" */
          output->extension := 16#15;
          latch->Op_code := (latch->Op_code and 16#F1FFFFEF) or 16#06000010
          )
        )                                /* End of coprocessor pre-decode */
      else
        (                                         /* Not for coprocessors */
        wait_for(Thumb_off_delay);

        if (latch->Dabt_svc) then Dabt_go?null;    /* Input from abort_go */

        output->extension := latch->extension
        );
                                 /* Common stuff for all ARM instructions */
      output->Op_code   := latch->Op_code;
      output->LSB       := 0;
      output->special   := false;
      output->PC        := latch->PC;

      Out!output
      )                                                       /* ARM mode */
    )
  ).

/*------------------------------------------------------------------------*/

null

/*------------------------------------------------------------------------*/
