/*------------------------------------------------------------------------*/
/*                                                                        */
/*                           AMULET3 Thumb decoder                        */
/*                         Special unlatched version                      */
/*                                                                        */
/*                                            Skeleton: JDG  13/1/97      */
/*                                            Modified: JDG  26/2/97      */
/*                                            Body added: JVW 5/3/97      */
/*                                            Modified: JDG   4/7/97      */
/*                                                                        */
/*------------------------------------------------------------------------*/
/*                                                                        */
/* Dabt_svc is no longer used                                             */
/*                                                                        */
/*------------------------------------------------------------------------*/

Thumb(In      : var(chan(Instr_pkt_type)),
      Out     : var(chan(Instr_pkt_type2)),
      Dabt_go : var(chan(void))):
      expr(void)=
 (
  output  : var(Instr_pkt_type2).

  forever (In?
    (
    output->PSR_ctrl := (?In)->PSR_ctrl;        /* Invariant in this unit */
    output->colour   := (?In)->colour;          /* Invariant in this unit */
    output->Dabt_svc := (?In)->Dabt_svc;        /* Invariant in this unit */

    if ((?In)->PSR_ctrl->Thumb) then
      (                                                  /* In Thumb mode */
      PC_spec : var(int).

      PC_spec := (?In)->PC;
/* PC sent to Thumb Expander to suppress PC bit-1 for Format-12 Add to PC */

      if (((?In)->PC and 16#00000002) = 0) then  /* L.S. half word wanted */
        (
        wait_for(Thumb_on_delay);

        Thumb_Ex((?In)->Op_code,
                 output->LSB,
                 output->special,
                 output->Op_code,
                 PC_spec);
        if (((?In)->extension and 16#60) = 16#40) then /* Predicted "odd" */
          output->extension := 16#00             /* so no prediction here */
        else
          output->extension := (?In)->extension;               /* Default */
        output->PC := PC_spec;

        Out!output;

        PC_spec := (?In)->PC + 2         /* May be altered by ADD from PC */
        );

      /* Suppression of this cycle (after predicted branch) is optional   */
      if (((?In)->extension and 16#20) = 0) then   /* No prediction (yet) */
        (                                          /* Send M.S. half word */
        wait_for(Thumb_on_delay);

        Thumb_Ex((?In)->Op_code >> 16,
                 output->LSB,
                 output->special,
                 output->Op_code,
                 PC_spec);
        output->extension := (?In)->extension;
        output->PC        := PC_spec;

        Out!output
        )
      )                                                     /* Thumb mode */
    else
      (                                                    /* In ARM mode */
      if (((?In)->extension = 0) &&       /* Possible copro. instruction? */
          ((((?In)->Op_code and 16#0E000000) = 16#0C000000)
        || (((?In)->Op_code and 16#0F000000) = 16#0E000000))) then
        (
        wait_for(Copro_dec_delay);    /* Poll coprocessors: is op. taken? */

/* This should really talk to the coprocessors rather than call a function*/

                                        /* Coprocessor wants instruction? */
        if copro_test((?In)->Op_code) then 
          output->extension := (?In)->extension /* Yes, continue normally */
        else
          output->extension := 16#15           /* No, make as "undefined" */
        )                                /* End of coprocessor pre-decode */
      else
        (                                         /* Not for coprocessors */
        wait_for(Thumb_off_delay);

        if ((?In)->Dabt_svc) then Dabt_go?null;    /* Input from abort_go */

        output->extension := (?In)->extension
        );
                                 /* Common stuff for all ARM instructions */
      output->Op_code   := (?In)->Op_code;
      output->LSB       := 0;
      output->special   := false;
      output->PC        := (?In)->PC;

      Out!output
      )                                                       /* ARM mode */
    ))                                                    /*  ... and ack */
  ).

/*------------------------------------------------------------------------*/

null

/*------------------------------------------------------------------------*/
