
/* stump processor core */

stump(iaddr:var(chan(int)),
      idata:var(chan(int)),
      daddrctrlstdata:var(chan(daddrctrlstdata_t)),
      dlddata:var(chan(int))):expr(void)=(
      
  /* simple fetch-decode-execute pipeline with colour for cancelling
     wrongly prefetched instructions */

  /* channels for interconnection */

  branchtgt:var(chan(int)).     /* new branch targets from execute to
                                   fetch */
  instr_bundle:var(chan(instr_bundle_t)).
                                /* instruction and its colour */
                                /* also includes the pc value for this
                                   instruction */
  decoded_instr_bundle:var(chan(decoded_instr_bundle_t)).
                                /* decoded instruction and its colour */
                                /* also includes the pc value for this
                                   instruction */

  init_chan(branchtgt,"branchtgt");
  init_chan(instr_bundle,"instr_bundle");
  init_chan(decoded_instr_bundle,"decoded_instr_bundle");
  
  (
    "fetch"   is fetch(iaddr,idata,branchtgt,instr_bundle) |
    "decode"  is decode(instr_bundle,decoded_instr_bundle) |
    "execute" is execute(decoded_instr_bundle,branchtgt,daddrctrlstdata,
                         dlddata)
  )
).

null
