
/* fetch unit */

fetch(iaddr:var(chan(int)),
      idata:var(chan(int)),
      branchtgt:var(chan(int)),
      instr_bundle:var(chan(instr_bundle_t))):expr(void)=(
  
  /* fetch autonomously until a branch target arrives,
     then change colour and fetch from the branch target. */
  
  /* in this version there is a latch in the incoming branch target
     stream.  This eliminates a potential deadlock. */
  
  fetch_colour:var(bool).
  pc:var(int).
  instr_bundle_v:var(instr_bundle_t).
  branchtgt_lt:var(chan(int)).
  br:var(int).
  
  init_chan(branchtgt_lt,"branchtgt_lt");
  fetch_colour:=false;
  pc:=0;
  
  (
    forever(
      branchtgt?(br:=?branchtgt);
      branchtgt_lt!br
    ) |
    forever(
      if (chan_ready(branchtgt_lt)) then (
        branchtgt_lt?(
          pc:=?branchtgt_lt;
          fetch_colour:=!fetch_colour
        )
      );
      ( iaddr!pc | idata?(instr_bundle_v->instr:=?idata) );
      instr_bundle_v->colour:=fetch_colour;
      instr_bundle_v->pc:=pc;
      instr_bundle!instr_bundle_v;
      pc:=pc+1
    )
  )
).

null
