
/* decoded instruction types for stump */

ccode_t:type=scalar.
  AL:val(ccode_t).
  NV:val(ccode_t).
  HI:val(ccode_t).
  LS:val(ccode_t).
  CC:val(ccode_t).
  CS:val(ccode_t).
  NE:val(ccode_t).
  EQ:val(ccode_t).
  VC:val(ccode_t).
  VS:val(ccode_t).
  PL:val(ccode_t).
  MI:val(ccode_t).
  GE:val(ccode_t).
  LT:val(ccode_t).
  GT:val(ccode_t).
  LE:val(ccode_t).

itype_t:type=scalar.
  ADD:val(itype_t).
  ADC:val(itype_t).
  SUB:val(itype_t).
  SBC:val(itype_t).
  AND:val(itype_t).
  OR:val(itype_t).
  LOAD:val(itype_t).
  STORE:val(itype_t).
  BRANCH:val(itype_t).

shift_t:type=scalar.
  no_shift:val(shift_t).
  ASR:val(shift_t).
  ROR:val(shift_t).
  RRC:val(shift_t).

format_t:type=scalar.
  onesource:val(format_t).
  twosource:val(format_t).

decoded_instr_t:type=record(ccode::ccode_t,   /* condition code */
                            itype::itype_t,   /* instruction type */
                            shift::shift_t,   /* shift op */
                            format::format_t, /* format: 1 or 2 src regs */
                            srcA::int,        /* first src reg num */
                            srcB::int,        /* second src reg num */
                            immediate::int,   /* immediate operand */
                            branch_offset::int,
                                              /* branch offset */
                            dest::int,        /* destination reg num */
                            set_cc::bool      /* set cond codes? */
                           ).

decoded_instr_bundle_t:type=record(decoded_instr::decoded_instr_t,
                                   colour::bool,
                                   pc::int).
                                   
null
