

disassemble(di:val(decoded_instr_t)):expr(string)=(
  
  s:var(string).
  
  append(bit:val(string)):expr(void)=(
    newstringvalparam(bit);
    s:=s@bit;
    endstringvalparam(bit)
  ).

  aluop:expr(void)=(
    if (di->set_cc) then (
      append("S")
    );
    append(" r"@i2s(di->dest)@", r"@i2s(di->srcA)@", ");
    case (di->format)
      when onesource => (
        append("#"@i2s(di->immediate))
      )
      when twosource => (
        append("r"@i2s(di->srcB));
        case (di->shift)
          when no_shift => null
          when ASR => append(", ASR")
          when ROR => append(", ROR")
          when RRC => append(", RRC")
      )
  ).

  memop:expr(void)=(
    append("r"@i2s(di->dest)@", [r"@i2s(di->srcA)@", ");
    case (di->format)
      when onesource => (
        append("#"@i2s(di->immediate))
      )
      when twosource => (
        append("r"@i2s(di->srcB));
        case (di->shift)
          when no_shift => null
          when ASR => append(", ASR")
          when ROR => append(", ROR")
          when RRC => append(", RRC")
      );
    append("]")
  ).

  branchop:expr(void)=(
    case (di->ccode)
      when AL => append("BAL")
      when NV => append("BNV")
      when HI => append("BHI")
      when LS => append("BLS")
      when CC => append("BCC")
      when CS => append("BCS")
      when NE => append("BNE")
      when EQ => append("BEQ")
      when VC => append("BVC")
      when VS => append("BVS")
      when PL => append("BPL")
      when MI => append("BMI")
      when GE => append("BGE")
      when LT => append("BLT")
      when GT => append("BGT")
      when LE => append("BLE");
    append(" +"@i2s(di->branch_offset))
  ).


  newstringvar(s);
  s:="";
  case (di->itype)
    when ADD => (
      append("ADD");
      aluop
    )
    when ADC => (
      append("ADC");
      aluop
    )
    when SUB => (
      append("SUB");
      aluop
    )
    when SBC => (
      append("SBC");
      aluop
    )
    when AND => (
      append("AND");
      aluop
    )
    when OR => (
      append("OR");
      aluop
    )
    when LOAD => (
      append("LD ");
      memop
    )
    when STORE => (
      append("ST ");
      memop
    )
    when BRANCH => (
      branchop
    );
  returnstringvar(s)
).

null

