
/* execute unit */

/* execute unit */

execute(decoded_instr_bundle:var(chan(decoded_instr_bundle_t)),
        branchtgt:var(chan(int)),
        daddrctrlstdata:var(chan(daddrctrlstdata_t)),
        dlddata:var(chan(int))):expr(void)=(
  
  expected_colour:var(bool).
  regs:var(int^7).
  pc:var(int).
  dec_instr:var(decoded_instr_t).
  c_shift:var(bool).
  cc:var(record(N::bool,Z::bool,V::bool,C::bool)).
  decoded_instr_bundle_v:var(decoded_instr_bundle_t).
  daddrctrlstdata_v:var(daddrctrlstdata_t).
  
  branchto(target:val(int)):expr(void)=(
    branchtgt!target;
    expected_colour:=!expected_colour
  ).

  get_reg(regnum:val(int)):expr(int)=(
    case regnum
      when 0 => 0
      when 7 => pc+1
      default   regs[regnum]
  ).

  set_reg(regnum:val(int),value:val(int)):expr(void)=(
    case regnum
      when 0 => null
      when 7 => branchto(value)
      default   regs[regnum]:=value
  ).

  srcA:expr(int)=(

    /* operand A always comes from a register. */
    /* when operand B also comes from a register, operand A is
       optionally shifted */

    regval:var(int).

    regval:=get_reg(dec_instr->srcA);
    case dec_instr->format
      when onesource => (
        c_shift:=false;
        regval
      )
      when twosource => (
        case dec_instr->shift
          when no_shift => (
            c_shift:=false;
            regval )
          when ASR => (
            c_shift:=(regval and 1)=1;
            ((regval>>1) or (regval and (1<<15))) )
          when ROR => (
            c_shift:=(regval and 1)=1;
            ((regval>>1) or ((regval and 1)<<15)) )
          when RRC => (
            c_shift:=(regval and 1)=1;
            ((regval>>1) or (if cc->C then 1<<15 else 0)) )
      )
  ).

  srcB:expr(int)=(
    case dec_instr->format
      when onesource => dec_instr->immediate
      when twosource => get_reg(dec_instr->srcB)
  ).

  cond_code_pass:expr(bool)=(
    case dec_instr->ccode
      when AL => true
      when NV => false
      when HI => !(cc->C||cc->Z)
      when LS => cc->C||cc->Z
      when CC => !cc->C
      when CS => cc->C
      when NE => !cc->Z
      when EQ => cc->Z
      when VC => !cc->V
      when VS => cc->V
      when PL => !cc->N
      when MI => cc->N
      when GE => cc->N=cc->V
      when LT => cc->N!=cc->V
      when GT => !((cc->N!=cc->V)||cc->Z)
      when LE => (cc->N!=cc->V)||cc->Z
  ).

  arith_op(dest:val(int),op1:val(int),op2:val(int),cin:val(bool))
          :expr(void)=(

    sum:var(int).
    
    sum:=op1+op2+(if cin then 1 else 0);
    set_reg(dest,sum and 16#FFFF);
    if (dec_instr->set_cc) then (
      cc->C:=(sum and 1<<16)!=0;
      cc->V:= /* not implemented */ false;
      cc->Z:=(sum and 16#FFFF)=0;
      cc->N:=(sum and (1<<15))!=0
    )
  ).

  logical_op(dest:val(int),result:val(int)):expr(void)=(
    set_reg(dest,result);
    if (dec_instr->set_cc) then (
      cc->C:=c_shift;
      cc->V:=false;
      cc->Z:=result=0;
      cc->N:=(result and (1<<15))!=0
    )
  ).

  
  expected_colour:=false;
  export_var(pc,"stump_pc");


  forever(
    decoded_instr_bundle?(decoded_instr_bundle_v:=?decoded_instr_bundle);
    wait_for(20);
    if (decoded_instr_bundle_v->colour=expected_colour) then (
      wait_for(20);
      pc:=decoded_instr_bundle_v->pc;
      update_export_var("stump_pc");
      dec_instr:=decoded_instr_bundle_v->decoded_instr;
      msg(disassemble(dec_instr));
      case dec_instr->itype
        when ADD =>
          arith_op(dec_instr->dest,srcA,srcB,false)
        when ADC =>
          arith_op(dec_instr->dest,srcA,srcB,cc->C)
        when SUB =>
          arith_op(dec_instr->dest,srcA,not srcB,true)
        when SBC =>
          arith_op(dec_instr->dest,srcA,not srcB,!cc->C)
        when AND =>
          logical_op(dec_instr->dest,srcA and srcB)
        when OR =>
          logical_op(dec_instr->dest,srcA or srcB)
        when LOAD => (
          daddrctrlstdata_v->addr:=((srcA+srcB) and 16#FFFF);
          daddrctrlstdata_v->store:=false;
          ( daddrctrlstdata!daddrctrlstdata_v |
            dlddata?(set_reg(dec_instr->dest,?dlddata)) ) )
        when STORE => (
          daddrctrlstdata_v->addr:=((srcA+srcB) and 16#FFFF);
          daddrctrlstdata_v->store:=true;
          daddrctrlstdata_v->stdata:=get_reg(dec_instr->dest);
          daddrctrlstdata!daddrctrlstdata_v )
        when BRANCH =>
          if (cond_code_pass) then (
            msg("condtion pass");
            branchto((pc+1+dec_instr->branch_offset) and 16#FFFF)
          ) else (
            msg("condition fail")
          )
    ) else (
      msg("wrong colour")
    )
  )
).

null
